#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <time.h>

#include "libRAM.h"
#include "libIO.h"

/***********************************************************/
/* PROTOTYPES                                              */
/***********************************************************/
void TEXT_COPYRIGHT(void);
void TEXT_MOVE_COUNT(void);
void TEXT_DIFFICULTY(void);

int  SCAN_FOR_IMAGES(char Extension[4]);
void SCAN_WINDOW(void);
void SCAN_FILE_DISPLAY(int start, int puzzles);

int  NEW_LOAD(char FileName[80]);
void NEW_DRAW(void);
void NEW_HELPVIEW_RECORD(void);
void NEW_CUTUP_IMAGE(void);
void NEW_RANDOMIZE_IMAGE(void);

void PUZZLE_SAVE(char FileName[80]);
void PUZZLE_LOAD(void);

void RECOVER_RECORD(void);
void RECOVER_DRAW();

void REDRAW_BLANK_PIECE(GLint x, GLint y);
void PLAY_WINNER(void);
void PLAY_ISWINNER(int x, int y);
void PLAY(int x, int y);

void HELP_UNDO(void);
void HELP_VIEW(void);
void HELP_NUMBER(void);

void RESIZE_COPY(void);
void RESIZE_RESTORE(void);

/***********************************************************/
/* GLOBAL VARIABLES                                        */
/***********************************************************/
#define version "7.0"

#define puzzleW   520
#define puzzleH   425
#define helpViewW 90
#define helpViewH 74

typedef unsigned char uchar;

struct RGB {
  uchar r, g, b;
};

GLint window;
GLint subWindow;
GLint winHeight    = 480;
int   drawFlag     = 1;
int   scanFlag     = 0;
int   scanStart    = 0;
int   puzzles      = 0;
int   loadFlag     = 0;
int   playFlag     = 0;
int   winFlag      = 0;
int   difficulty   = 1;
int   movesMade    = 0;
int   movesToSolve = 0;
int   PuzzleMoves[6][500];
int   PuzzleBoard[5][5];
char  PuzzleName[80];
char  PuzzleNames[100][80];
RGB   PuzzleData[puzzleH][puzzleW];
RGB   PuzzleView[helpViewW][helpViewH];
RGB   RecoverData[400][300];

/***********************************************************/
/* WINDOWS                                                 */
/***********************************************************/
WINDOW PLAY_WINDOW(113,   9, puzzleW+1, puzzleH+1);
WINDOW MOVE_WINDOW(  7, 450, 100, 20);
WINDOW LEVL_WINDOW(533, 450, 100, 20);
WINDOW HELP_WINDOW(  9,  17, helpViewW+2, helpViewH+2);
 
WINDOW FILE_WINDOW(235,  30, 175, 380); 

/***********************************************************/
/* BUTTONS                                                 */
/***********************************************************/
BUTTON NEWG_BUTTON( 20, winHeight- 90, "New");
BUTTON LVLP_BUTTON( 20, winHeight-115, "Level +");
BUTTON LVLN_BUTTON( 20, winHeight-140, "Level -");
BUTTON PLAY_BUTTON( 20, winHeight-165, "Play");
BUTTON LOAD_BUTTON( 20, winHeight-190, "Load");
BUTTON SAVE_BUTTON( 20, winHeight-215, "Save");
BUTTON EXIT_BUTTON( 20, winHeight-250, "Exit");

BUTTON LABL_BUTTON( 20, winHeight-330, "Number");
BUTTON VIEW_BUTTON( 20, winHeight-355, "View");

BUTTON UP___BUTTON(420, winHeight-310, "Up");
BUTTON DOWN_BUTTON(420, winHeight-335, "Down");
BUTTON CNCL_BUTTON(420, winHeight-385, "Cancel");















